
        ;       VDC Init (PAL) - tool for C128


*=$1c01

        ;       0 sys7181

        byte    $0b,$1c,$00,$00,$9e,$37,$31,$38,$31,$00,$00,$00

        jmp     main

msg     byte    $0d

        ;       "ntsc"/"pal"

msp     byte    $00,$00,$00,$00

        ;       "16k "

m16     byte    $20,$4b,$36,$31,$0d

        ;       esc-x/scnclr/esc-x

        byte    $58,$1b,$93,$58,$1b

        ;       "ntsc"/"pal"

msn     byte    $43,$53,$54,$4e
        byte    $00,$4c,$41,$50

wplp    bit     $d600
        bpl     wplp
        rts

vdlx    stx     $d600
vdld    jsr     wplp
        lda     $d601
        rts

vdsx    stx     $d600
vdst    jsr     wplp
        sta     $d601
        rts

main    php
        sei

        lda     $fffe
        ldy     $0a03
        ldx     #$2f
        eor     #$17

        sta     $06
        stx     $07
        beq     xain

        eor     #$5f
        bne     rett

        ldy     $02a6

        sta     $d02f
        lda     $d02f

        cmp     #$f8
        bcc     rett
        cmp     #$ff
        bcs     rett

xain    ldx     #$1c
        jsr     vdlx
        sta     $08
        sty     $09

        ;       detecting PAL/NTSC (by counting scanlines)

        jsr     ntsc

        ;       initializing VDC

        jsr     rvdc

        ;       detecting 16K/64K VRAM

        jsr     dvdc

        lda     $07
        ldx     #$1c
        jsr     vdsx

        ldx     $06
        bne     rugr

        ldx     #$0d
        cmp     $08
        beq     regr

        lda     $d7
        beq     regr

        ldx     #$93

regr    stx     m16+4

        ;       re-generating charset (if necessary)

        jsr     $ff62

        ;       DRAM Refreshing Rate = 0

rugr    ldx     #$24
        lda     #$00
        ldy     #$0e
        jsr     vdsx

        ldx     $06
        beq     repr

        dey
        sty     m16+4
        ldy     #$09

        ;       print message

repr    lda     msg,y
        jsr     $ffd2
        dey
        bpl     repr

rett    plp
        rts

        ;       detecting PAL/NTSC (by counting scanlines)

ntsc    ldx     #$00

ntpx    txa

ntpl    tay
        sta     $09
        lda     $d012
        cmp     $09
        bcs     ntpl

        iny
        beq     ntpx

        cpy     #$10
        ldx     #$01
        ldy     #$ff
        bcs     npal

        dex
        iny

npal    lda     $06
        bne     nplc

        ;       PAL/NTSC switch on C128

npla    sty     $0a03
        beq     nplx

        ;       PAL/NTSC switch on C64

nplc    stx     $02a6

nplx    lda     #$01
        sta     $09
        asl
        asl
        tax
        ldy     #$00

nplp    lda     msn,x
        sta     msp,y
        cpy     #$03
        inx
        iny
        bcc     nplp

        rts

set1    lda     #$10

setv    ldx     #$12
        jsr     vdsx

        inx
        lda     #$00
        jsr     vdsx

        ldx     #$1f
        stx     $d600
        jmp     wplp

        ;       detecting 16K/64K VRAM

dvdc    ldy     #$00
        jsr     set1
        lda     $d601
        sty     $09
        pha

dvlp    jsr     sety

        lda     #$90
        jsr     setv
        cpy     $d601
        bne     dvly

        inc     $09

dvly    iny
        bne     dvlp

        lda     #$36
        ldx     #$31

        dec     $09
        bne     dvla

        tax
        lda     #$3f
        sta     $07
        lda     #$34

dvla    sta     m16+2
        stx     m16+3

        pla
        tay

sety    jsr     set1
        sty     $d601
        rts

        ;       initializing VDC

rvdc    ldy     #$00
        jsr     crtc

        lda     $d600
        and     #$07
        beq     vvdc

        jsr     crtc

vvdc    lda     $09
        beq     rrtc

        ldy     #$3e

crtc    ldx     vtab,y
        bmi     yrtc

        iny
        lda     vtab,y

        jsr     vdsx

        iny
        bpl     crtc

yrtc    iny
rrtc    rts

        ;       CRTC 8563 Set Up Pairs <- from $e2f8 in C128 Kernal

vtab    byte    $00,$7e,$01,$50,$02,$66,$03,$49
        byte    $04,$20,$05,$00,$06,$19,$07,$1d
        byte    $08,$00,$09,$07,$0a,$20,$0b,$07
        byte    $0c,$00,$0d,$00,$0e,$00,$0f,$00
        byte    $14,$08,$15,$00,$17,$08,$18,$20
        byte    $19,$40,$1a,$f0,$1b,$00,$1c,$20
        byte    $1d,$07,$22,$7d,$23,$64,$24,$05
        byte    $16,$78,$ff

        byte    $19,$47,$ff

        byte    $04,$26,$07,$20,$00,$7f,$ff

        ;       compiled with CBM prg Studio v3.10 (by Arthur Jordison)
        ;       http://ajordison.co.uk/

        ;       Rosetta Interactive Fiction project homepage:

        ;       http://istennyila.hu/rosetta

        ;       v0.13 (c) 2012-2017 by Robert Olessak
